import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Exercice3 {
	
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		System.out.print("Entrez le chemin vers un fichier  copier: ");
		String from = scanner.nextLine();
		System.out.print("Entrez le chemin de destination: ");
		String to = scanner.nextLine();
		try {
			// Deux mthodes de copiage, en fonction du type de fichier identifi par son extension
			if (from.endsWith(".java")) {
				copieSansCommentairesJava(from, to);
			} else {
				copie(from, to);
			}
		} catch (IOException e) {
			System.out.println("Une erreur est survenue lors de la copie");
		}
		scanner.close();
	}

	static void copie(String filenameFrom, String filenameTo) throws IOException {
		BufferedReader bufferFrom;
		BufferedWriter bufferTo;
		try {
			// Ouverture d'un buffer en lecture
			bufferFrom = new BufferedReader(new FileReader(filenameFrom));
		} catch (FileNotFoundException e) {
			// Le fichier n'a pas t trouv, on s'arrte
			System.out.println(String.format("Le fichier '%s' n'existe pas", filenameFrom));
			return;
		}
		try {
			// Ouverture d'un buffer en criture
			bufferTo = new BufferedWriter(new FileWriter(filenameTo));
		} catch (IOException e) {
			// Une erreur est survenue, on s'arrte
			System.out.println(String.format("Erreur  l'ouverture en criture du fichier '%s'", filenameTo));
			return;
		}
		String line = "";
		// Lecture d'une ligne
		// Si on arrive au bout du fichier, "null" est retourn
		while ( (line = bufferFrom.readLine()) != null) {
			bufferTo.write(line+"\n");
		}
		// N'oubliez pas de fermer les tampons, sinon le texte qui s'y trouve est perdu
		bufferFrom.close();
		bufferTo.close();
	}
	
	static void copieSansCommentairesJava(String filenameFrom, String filenameTo) throws IOException {
		BufferedReader bufferFrom;
		BufferedWriter bufferTo;
		try {
			bufferFrom = new BufferedReader(new FileReader(filenameFrom));
		} catch (FileNotFoundException e) {
			System.out.println(String.format("Le fichier '%s' n'existe pas", filenameFrom));
			return;
		}
		try {
			bufferTo = new BufferedWriter(new FileWriter(filenameTo));
		} catch (IOException e) {
			System.out.println(String.format("Erreur  l'ouverture en criture du fichier '%s'", filenameTo));
			return;
		}
		String line = "";
		String trimmedLine = "";
		boolean inComment = false;
		while ( (line = bufferFrom.readLine()) != null) {
			// Mthode trs basique, les marqueurs de commentaires "//" et "/*" doivent se trouver sur une ligne sans aucun code
			trimmedLine = line.trim();
			if (trimmedLine.startsWith("//")) {
				continue;
			} else if (trimmedLine.startsWith("/*")) {
				inComment = true;
			} else if (trimmedLine.startsWith("*/")) {
				inComment = false;
			} else if (inComment) {
				continue;
			} else {
				bufferTo.write(line+"\n");
			}
		}
		bufferFrom.close();
		bufferTo.close();
	}
	
	
}
