import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Scanner;


public class Exercice4 {

	public static void main(String[] args) throws FileNotFoundException, IOException {
		Scanner scanner = new Scanner(System.in);
		// Nom et prnom
		System.out.print("Nom de l'tudiant: ");
		String lastname = scanner.nextLine();
		System.out.print("Prnom de l'tudiant: ");
		String name = scanner.nextLine();
		// Instantiation 
		Student student = new Student(lastname, name);
		// Notes
		student.addGrades( Exercice1.getGradesFromInput(scanner) );
		// Affichage de la moyenne
		System.out.println( String.format("L'tudiant %s a une moyenne de: %.2f", student, student.getAverageGrade()) );
		// Enregistrement de l'instance d'tudiant dans un fichier
		// (la mthode "main" lance les exceptions, nous n'essayons pas de les capturer ici)
		File filename = new File(student.getLastname().toLowerCase()+".student");
		System.out.println( "Sauvegarde du fichier tudiant dans le fichier: "+filename.getAbsolutePath() );
		ObjectOutputStream stream = new ObjectOutputStream( new FileOutputStream(filename) );
		stream.writeObject(student);
		// Ne jamais oublier de fermer le flux
		stream.close();
	}

}


@SuppressWarnings("serial")
class Student implements Serializable {
	
	String lastname;
	String name;
	transient String password;
	// "grades" signifie "notes" en franais
	ArrayList<Integer> grades;
	
	
	public Student(String lastname, String name) {
		this.lastname = lastname;
		this.name = name;
		this.password = "bingo";
		grades = new ArrayList<Integer>();
	}
	
	public String toString() {
		return String.format("%s %s", lastname, name);
	}
	
	public String getLastname() {
		return lastname;
	}
	
	public void addGrades(ArrayList<Integer> grades) {
		// Attention  ne pas confondre l'attribut "grades" avec le paramtre "grades"
		this.grades.addAll(grades);
	}
	
	public double getAverageGrade() {
		if (grades.size() == 0) {
			return 0.0;
		} else {
			// Utilisation d'un itrateur, une boucle "foreach" est nanmoins plus rapide  crire
			Iterator<Integer> iterator = grades.iterator();
			int total = 0;
			while (iterator.hasNext()) {
				total += iterator.next();
			}
			return ((double) total) / grades.size();
		}
	}
	
	
}
